=== debian/changelog ===
arb (6.0.2-1+deb8u1) jessie; urgency=medium

  * Skip compiler version check at all
    Closes: #793187

 -- Andreas Tille <tille@debian.org>  Thu, 10 Dec 2015 10:55:21 +0100

arb (6.0.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #741890
  * debian/upstream -> debian/upstream/metadata
  * debian/control:
     - Build-Depends: added libglib2.0-dev
     - Depends: added mafft, mrbayes
  * debian/rules
     - Add explicite --remove-section=.comment option to manual strip call
  * cme fix dpkg-control
  * arb-common.dirs: Do not create unneeded lintian dir
  * Add turkish debconf translation (thanks for the patch to Mert Dirik
    <mertdirik@gmail.com>)
    Closes: #757497

  [ Elmar Pruesse ]
  * patches removed:
     - 10_config.makefiles.patch,
       80_no_GL.patch
         removed in favor of creating file from config.makefile.template via 
         sed in debian/control
     - 20_Makefile_main.patch
         merged upstream
     - 21_Makefiles.patch
         no longer needed
     - 30_tmpfile_CVE-2008-5378.patch: 
         merged upstream
     - 50_fix_gcc-4.8.patch:
         merged upstream
     - 40_add_libGLU.patch:
         libGLU not needed for arb_ntree)
     - 60_use_debian_packaged_raxml.patch:
         merged upstream
     - 70_hardening.patch
         merged upstream
     - 72_add_math_lib_to_linker.patch
         does not appear to be needed
  * patches added:
     - 10_upstream_r12793__show_db_load_progress:
         backported patch showing progress while ARB is loading a database
         (needed as indicator/splash screen while ARB is launching)
     - 20_upstream_r12794__socket_permissions:
         backported security fix
     - 30_upstream_r12814__desktop_keywords:
         backported add keywords to desktop (fixes lintian warning)
     - 40_upstream_r12815__lintian_spelling:
         backported fix for lintian reported spelling errors
     - 50_private_nameservers
         change configuration to put nameservers into users home dirs
         (avoids need for shared writeable directory)
     - 60_use_debian_phyml
         use phyml from debian package for both interfaces in ARB
  * debian/rules:
     - create config.makefile from override_dh_configure target
     - use "make tarfile" in override_dh_install
     - remove extra cleaning not needed for ARB 6
     - use "dh_install --list-missing" to avoid missing files
     - added override_dh_fixperms target
  * debian/control:
     - added libarb-dev package
     - Depends: added phyml, xdg-utils
     - Suggests: removed phyml
     - fix lintian duplicate-short-description (new descriptions)
  * debian/*.install:
     - "unrolled" confusing globbing to select files
     - pick files from debian/tmp
     - moved all config files to /etc/arb
  * debian/arb-common.templates: updated
  * scripts:
     - removed arb-add-pt-server
     - launch-wrapper: 
       - only add demo.arb to newly created $ARBUSERDATA
       - pass commandline arguments through bin/arb wrapper
     - preinst: removing old PT server index files on upgrade from 5.5*
     - postinst: set setgid on shared PT dir
  * rewrote arb.1 manfile
  * added file icon for ARB databases
  * using upstream arb_tcp.dat

 -- Elmar Pruesse <elmar@pruesse.net>  Tue, 02 Sep 2014 15:15:06 +0200
