=== debian/control ===
Source: arb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Elmar Pruesse <elmar@pruesse.net>
Section: non-free/science
XS-Autobuild: yes
Priority: optional
Build-Depends: chrpath,
               debhelper (>= 9),
               freeglut3-dev | libglu-dev,
               libbio-perl-perl,
               libglew-dev,
               libglib2.0-dev,
               libglw1-mesa-dev,
               libglu1-mesa-dev,
               libmotif-dev,
               libpng-dev,
               libtiff-dev,
               libxaw7-dev,
               libxml2-utils,
               libxpm-dev,
               lynx,
               time,
               perl-doc,
               xsltproc,
               xutils-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/arb/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/arb/trunk/
Homepage: http://www.arb-home.de/

Package: arb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: arb-common (= ${source:Version}),
         fastdnaml,
         libarb (= ${binary:Version}),
         openssh-client,
         mafft,
         mrbayes,
         phylip,
         phyml,
         raxml,
         readseq,
         transfig,
         tree-puzzle,
         xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: bioperl,
            xfig
Suggests: arb-database,
          gnuplot,
          gv
Description: Graphical suite for phylogenetic sequence analysis 
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.

Package: libarb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: arb
Description: Graphical suite for phylogenetic sequence analysis (libraries)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package contains the dynamic libraries which are used by arb.

Package: libarb-dev
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Section: non-free/libdevel
Depends: libarb (= ${binary:Version}),
         ${misc:Depends}
Description: Graphical suite for phylogenetic sequence analysis (development files)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package contains headers and static libs needed to link against libARBDB.

Package: arb-common
Architecture: all
Depends: adduser,
         arb-doc (= ${source:Version}),
         ghostscript | postscript-preview,
         gv | postscript-viewer,
         perl-modules,
         ${misc:Depends},
         ${perl:Depends}
Recommends: arb
Description: Graphical suite for phylogenetic sequence analysis (common files)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the architecture independent scripts of Arb.

Package: arb-doc
Architecture: all
Section: non-free/doc
Depends: ghostscript | postscript-preview,
         gv | postscript-viewer,
         ${misc:Depends}
Suggests: arb
Description: Graphical suite for phylogenetic sequence analysis (documentation)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the documentation for the package arb.
